#!/usr/bin/env python

# Copyright 2008 Vojtech Kovar

# This file is part of SET.
#
# SET is free software: you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation, either version 3 of the License, or
# (at your option) any later version.
#
# SET is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with SET.  If not, see <http://www.gnu.org/licenses/>.


# reading vertical files, class VerticalProcessor

import re, sys
import settings

tag_re = re.compile('^<.*>')
s_re = re.compile('^</?s[> ]')
head_re = re.compile('^</?head[> ]')

class VerticalProcessor():

	def __init__(self, file):
		self.file = file

	def get_sentence(self, out_file=sys.stdout):
		result = []
		line = self.file.readline()
		while line:
			if (s_re.match(line) or head_re.match(line)) and result:
#				out_file.write(line)
				return result, line
			if not tag_re.match(line):
				result.append(line)
			if tag_re.match(line) and not settings.IGNORETAGS:
				out_file.write(line)
			line = self.file.readline()
		return result, ''



